Introduction
------------

This is the program used in the paper "New Exact Approaches to Row Layout Problem" (rev. 2) by Anja Fischer, Frank Fischer and Philipp Hungerländer.

Compiling and Running the Program
---------------------------------

The program can be compiled using the provided `Makefile`. To this end the paths
to the local installation of `Gurobi` and `Cplex` in the `Makeifle` should be
adapted. The program can be compiled by running

    make

To run the program and get information on all options run

    ./rowlayout --help
    
    
Instance format
---------------

The folders

 - instances_drf
 - instances_kprop
 - instances_prop
 - inst_mult
 - inst_mult_L

contain a collection of the used instances in the following format for each of the problem types. Each file consists of a sequence of whitespace separated numbers.

1. PROP and KPROP
   - `n` ... number of departments
   - `m` ... number of rows
   - `n_i` ... the number of departments in each row i = 1, ..., m
   - `l_i` ... lengths of the departments i = 1, ..., n
   - matrix `W=(w_ij)` of the connectivities
     
         for i = 1:n
             for j = 1:n
                 w_ij
             end
         end

     (Note: only the upper right triangle of the matrix is considered in our program.)

2. (SF-)DRFLP and (SF-)MRFLP
   - `n` ... number of departments
   - `l_i` ... lengths of the departments i = 1, ..., n
   - matrix `W_(w_ij)` of the connectivities
     
         for i = 1:n
             for j = 1:n
                 w_ij
             end
         end



