/*
 * This program is free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see  <http://www.gnu.org/licenses/>
 */

#ifndef __AMARALMODEL_HXX__
#define __AMARALMODEL_HXX__

#include "BaseModel.hxx"

/// Basic model of Amaral for (SF-)DRFLP and extension by Secchin & Amaral.
class AmaralModel: public BaseModel
{
protected:
    /// special variables
    std::vector<std::vector<Variable*> > _a_variables;
    /// position variables
    std::vector<Variable*> _p_variables;

    AmaralModel();

public:
    AmaralModel(Problem& problem, bool use_cuts);

    std::vector<std::vector<ID> > compute_solution(const std::vector<double>& x);

protected:
    void init_p_variables();

    void init_a_variables();

    void init_amaral_constraints();


};

#endif
