/*
 * This program is free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see  <http://www.gnu.org/licenses/>
 */

#ifndef __DRFLPBETWEENNESSMODEL_HXX__
#define __DRFLPBETWEENNESSMODEL_HXX__

#include "BetweennessModel.hxx"

class DRFLPBetweennessModel: public BetweennessModel
{
private:
    double _bigm;

public:
    DRFLPBetweennessModel(Problem& problem,
                          const rows_vec& rows, bool use_cuts,
                          double bigm,
                          double upper = std::numeric_limits<double>::infinity());

    void init();

    void separate(const std::vector<double>& x, Separator& separator);

protected:
    void init_drflp_constraints();
};

#endif
