/*
 * This program is free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see  <http://www.gnu.org/licenses/>
 */

#ifndef __DEPARTMENT_HXX__
#define __DEPARTMENT_HXX__

#include "Types.hxx"

class Problem;

// A department.
class Department
{
private:


    ID _id;
    const Problem* _problem;
    double _length;
    size_type _row;

public:
    Department():
        _id(NO_ID),
        _problem(NULL),
        _length(0),
        _row(0) { }


    // Define and return data
    ID get_id() const { return _id; }
    void set_id( ID id ) { _id = id; }
    const Problem* get_problem() const { return _problem; }
    void set_problem( const Problem* problem ) { _problem = problem; }
    double get_length() const { return _length; }
    void set_length( double length ) { _length = length; }
    size_type get_row() const { return _row; }
    void set_row( size_type row ) { _row = row; }


};



#endif
