/*
 * This program is free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see  <http://www.gnu.org/licenses/>
 */

#include "Error.hxx"

namespace lyutil {

RuntimeError::RuntimeError(const std::string& name):
    std::runtime_error( name.c_str() )
{}

RuntimeError::RuntimeError(const std::string& name,
                           const std::string& msg):
    std::runtime_error( (name + ": " + msg).c_str() )
{}

RuntimeError::RuntimeError(const std::string& name,
                           const std::string& where,
                           const std::string& msg):
    std::runtime_error( (name + ": (" + where + "): " + msg).c_str() )
{}


void throw_error()
{
    return;
}

}
