/*
 * This program is free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see  <http://www.gnu.org/licenses/>
 */

#include "InitSeparator.hxx"

#include "Types.hxx"

InitSeparator::InitSeparator(std::vector<Constraint*>& constraints):
    _constraints(constraints)
{}

InitSeparator::~InitSeparator()
{}

bool InitSeparator::add_if_violated(const coeff_vec& vars,
                                    Constraint::Sense sense,
                                    double rhs)
{
    Constraint* c = new Constraint(sense, rhs);
    for (size_type i = 0; i < vars.size(); i++)
        c->add_coeff(vars[i].first, vars[i].second);
    _constraints.push_back(c);
    return true;
}
