/*
 * This program is free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see  <http://www.gnu.org/licenses/>
 */

#ifndef __READER_HXX__
#define __READER_HXX__

#include "Types.hxx"

#include <memory>
#include <string>
#include <vector>

class Department;
class Problem;

// Reads the problem from a file.
class Reader
{
private:
    std::string _transport_fname;
    bool _has_rows;

public:

    Reader(const std::string& transport_fname, bool has_rows);

    std::unique_ptr<Problem> read_problem() const;

private:
    static std::vector<std::string> split( const std::string& line ) ;
};

#endif
