/*
 * This program is free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see  <http://www.gnu.org/licenses/>
 */

#ifndef __SAMODELCOMMON_HXX__
#define __SAMODELCOMMON_HXX__

#include "AmaralModel.hxx"

class Separator;

/// Common functions for SA model.
class SAModelCommon: public virtual AmaralModel
{
public:
	SAModelCommon();

protected:
    /// Amaral betweenness variables
    std::vector<std::vector<std::vector<Variable*> > > _e_variables;    
    void init_e_variables();
    void init_e_constraints();
    void init_sa_base_constraints();
	void separate_e_constraints(Separator& separator);
	void separate(const std::vector<double>& /*x*/, Separator& separator);
};

#endif
