/*
 * This program is free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see  <http://www.gnu.org/licenses/>
 */

#ifndef __SFDRFLPBNBSOLVER_HXX__
#define __SFDRFLPBNBSOLVER_HXX__

#include "BnBSolver.hxx"

// submodels for SF-DRFLP for B&B

class SFDRFLPBnBSolver: public BnBSolver
{
private:
    bool _use_reduce;

public:
    SFDRFLPBnBSolver(Problem& problem, bool use_cuts, bool use_reduce, MIPSolver& solver);

    SFDRFLPBnBSolver(Problem& problem, size_type nrows, bool use_cuts, bool use_reduce, MIPSolver& solver);

protected:
    std::unique_ptr<BetweennessModel> create_submodel(const rows_vec& rows, double upper);

    bool check_valid(const std::vector<double>& lens, double /*l0max*/);
};

#endif
