/*
 * This program is free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see  <http://www.gnu.org/licenses/>
 */

#ifndef __LYUTIL_TIMER_HXX__
#define __LYUTIL_TIMER_HXX__

#include <iosfwd>
#include <time.h>
#include <string>

// timer for measuring the running times

namespace lyutil {

class Timer
{

public:
    Timer(bool autostart = false);

    ~Timer();

    void start(bool restart = false);

    void stop();

    double time() const;

    void show(std::ostream& o) const;

    std::string str() const;

private:
    bool _running;
    clock_t _start_time, _stop_time;
    bool _started;

    static const clock_t SC_CLK_TCK;
};

std::ostream& operator<<(std::ostream& o, const Timer& timer);
}

#endif
